From 301a682f90ba6c0aa8d393f8dd8a45b64234e19f Mon Sep 17 00:00:00 2001
From: Jean-Baptiste Holcroft <jean-baptiste@holcroft.fr>
Date: Jun 17 2019 22:58:14 +0000
Subject: [PATCH 1/3] add total messages+words harmonization


---

diff --git a/build_stats.py b/build_stats.py
index 0449336..4cb3d89 100755
--- a/build_stats.py
+++ b/build_stats.py
@@ -79,6 +79,11 @@ def parse(concat):
     data = check_lang_territory_consistency(data)
     info(data, "cldr consistency are done")
 
+    data = harmonize_totals(data)
+    info(data, "data harmonization are done")
+
+    data = summary(data)
+
     store(data, "3.result.csv")
 
 
@@ -278,6 +283,50 @@ def check_lang_territory_consistency(data):
 
     return data
 
+def harmonize_totals(data):
+    """ po files may be outdate, hypothese: max(source string)=truth"""
+
+    #miaw = data.groupby(['src'], sort=False)
+    #miaw['totalMessage_max'] = miaw['totalMessage'].max()
+
+    # there could be multiple translation files for one language on a same project
+    data['dirname'] = data['filename'].apply(os.path.dirname)
+
+    max = data.groupby(['src','dirname'], sort=False)['totalMessage'].max().rename("totalMessageMax").reset_index()
+    data = data.merge(max)
+    #data['untranslatedMessages'] += data['totalMessageMax'] - data['totalMessage']
+
+
+    max = data.groupby(['src','dirname'], sort=False)['totalSourceWords'].max().rename("totalSourceWordsMax").reset_index()
+    data = data.merge(max)
+    #data['untranslatedSourceWords'] += data['totalSourceWordsMax'] - data['totalSourceWords']
+
+    #data = data.drop('totalMessageMax', 1)
+    #data = data.drop('totalSourceWordsMax', 1)
+
+    return data
+
+def summary(data):
+
+    stat1 = data[['language', 'territory', 'script']].drop_duplicates().count().max()
+    stat2 = data['src'].drop_duplicates().count()
+    stat3 = data[['src', 'filename']].drop_duplicates().count().max()
+    stat4 = data['language'].drop_duplicates().count()
+    stat5 = data.groupby(['src','dirname'])['totalMessageMax'].max().sum()
+    stat6 = data.groupby(['src','dirname'])['totalSourceWordsMax'].max().sum()
+
+    print("")
+    print("We have:")
+    print("  * number of upstream sources: "+str(stat2))
+    print("  * number of distinct lang-script-territory: "+str(stat1))
+    print("  * number of languages: "+str(stat4))
+    print("  * translation files: "+str(stat3))
+    print("This represents:")
+    print("  * Total messages: "+str(stat5))
+    print("  * Total words: "+str(stat6))
+    print("")
+
+    return data
 
 def info(dataset, step):
     """Print basic informations about current dataset"""
